/* *******************************************************************
   Web CLIENT
   This are the webclient function to push data from Arduino to another webserver.
   MISSING/TODO client umbauen auf streamlib
   ***************************************************************** */

// Timer to log some data to SD Card
// this Version is failsafe using a Store an Forward storage if external server is not available
void timerClient()
{
  const uint32_t interval = 30 * 1000UL;
  static uint32_t previousMillis = 0;
  if (millis() - previousMillis > interval)
  {
    previousMillis = millis();
    clientTrigger();
  }
}

// try to transmit data to server or write SAF
void clientTrigger()
{
    const uint16_t MESSAGE_SIZE_MAX = 64;                           // maximum bytes for Message Buffer
    char message[MESSAGE_SIZE_MAX];                                 // the temporary sending message - html body
    createPayload(message);
    Serial.print(F("[client]D018 message=")); Serial.println(message);
    
    char filename[fileLen];
    strcpy(filename, oldestSafFileDefault);
    uint32_t safFiles = safCountFile(filename);

    if (safFiles == 0)                                                          // check if SAF is empty
    {
      Serial.println(F("[client]I: SAF empty - continue client"));
      byte result = sendMessage(message);
      Serial.print(F("[client]D024 result=")); Serial.println(result);
      if (result != 1 && timeStatus() != timeNotSet) safStore(message);         // if we get an error, we safe the payload locally into SAF MISSING: use created message
    }
    else
    {
      if (timeStatus() != timeNotSet)
      {
        Serial.println(F("[client]I: SAF available - append current data to SAF"));
        safStore(message);
      }
      else
        Serial.println(F("[client]E: SAF available but time not set. Can't generate SAF file without timestamp"));
    }
    Serial.println(F("[client]D027 END"));
}

// fill a buffer with the payload to be send as message (or stored to SAF)
// MISSING use Reference 
void createPayload(char * message)
{
  Serial.println(F("[client]D148 createPayload()"));
  char val[32];                                                   // to convert floats and integers before appending
  uint32_t epoche = now();
  // payload to transmit MISSING: should be reused in client
  strcpy(message, "board=");
  strcat(message, TXT_BOARDID);
  strcat(message, "&sdeov=");
  ultoa(epoche, val, 10);
  strcat(message, val);
  strcat(message, "&sgem=");
  itoa(analogRead(analogPin[0]), val, 10);
  strcat(message, val);
  strcat(message, "&scem=");
  itoa(analogRead(analogPin[1]), val, 10);
  strcat(message, val);

  //Serial.print(F("[client]D066 message=")); Serial.println(message);
  //Serial.print(F("[client]D067 strlen="));  Serial.println(strlen(message));
}

// client function to send a message buffer as POST data
// return 0 started
// return 1 success
// return 9 error
byte sendMessage(char message[])
{
#if CLIENT_DEBUG_USART
  Serial.println(F("[client]D077 sendMessage() "));
#endif
  Serial.println(F("[client]D079 sendMessage() "));
  //Serial.print(F("[client]D080 message=")); Serial.println(message);
  //Serial.print(F("[client]D081 strlen=")); Serial.println(strlen(message));
  //boolean content = false;
  byte returncode = 0;
  //char receiveBuffer[32];  // will store received line - currently we only need T86400\0 = 7 indexes
  //memcpy(receiveBuffer, "", 32);

  if (client.connect(myserver, 80)) {                               // currently we need a deactivated Watchdog for this line otherwise Servertimeout would result in a wdt action!
    Serial.println(F("[client]I: client connected"));
    returncode = 1;
    client.println(F("POST " HTTP_CLIENT_SERVERPFAD " HTTP/1.1"));
    client.println(F("Host: " HTTP_CLIENT_SERVERNAME));
    client.println(F("Connection: close"));
    client.println(F("Content-Type: application/x-www-form-urlencoded"));        // kein abschließender ; ???

    uint16_t messageLength = strlen(message);
    client.print(F("Content-Length: ")); client.println(messageLength);
    client.println();                                   // empty line as end marker of HTTP-Header before the payload
    client.print(message);
    client.flush();
#if CLIENT_DEBUG_USART
    Serial.print(F("\n[client]D101 messageLength=")); Serial.println(messageLength);
    Serial.println(message);
#endif
  }
  else {
    Serial.print  (F("[client]E106 client failed. ms=")); Serial.println(millis());
    returncode = 9;
  } //if client.connected

  // in this sketch we don't read the server response

  delay(1); // wait for transmit?
  client.stop();

  //Serial.println(F("[client]D213 sendMessage() END"));
  return returncode;
}


/*
// client function to send POST data
// return 0 started
// return 1 success
// return 9 error
byte sendPost()
{
#if CLIENT_DEBUG_USART
  Serial.print(F("D021 start sendPost V10 ")); Serial.println(millis());
#endif
  boolean content = false;
  byte returncode = 0;
  char receiveBuffer[32];  // will store received line - currently we only need T86400\0 = 7 indexes
  memcpy(receiveBuffer, "", 32);

  if (client.connect(myserver, 80)) {                               // currently we need a deactivated Watchdog for this line otherwise Servertimeout would result in a wdt action!
    Serial.println(F("I: client connected"));
    returncode = 1;
    const uint16_t MESSAGE_SIZE_MAX = 64;                           // maximum bytes for Message Buffer
    char message[MESSAGE_SIZE_MAX];                                 // the temporary sending message - html body
    char val[32];                                                   // to convert floats and integers before appending

    client.println(F("POST " HTTP_CLIENT_SERVERPFAD " HTTP/1.1"));
    client.println(F("Host: " HTTP_CLIENT_SERVERNAME));
    client.println(F("Connection: close"));
    client.println(F("Content-Type: application/x-www-form-urlencoded"));        // kein abschließender ; ???
    // and now prepare/buffer the HTML-Body
    strcpy(message, "board=");
    strcat(message, TXT_BOARDID);

    // payload to transmit:
    strcat(message, "&sdeov=");
    dtostrf(now(), 1, 2, val);
    strcat(message, val);
    strcat(message, "&sgem=");
    dtostrf(analogRead(analogPin[0]), 1, 2, val);
    strcat(message, val);
    strcat(message, "&scem=");
    dtostrf(analogRead(analogPin[1]), 1, 2, val);
    strcat(message, val);
    //strcat(message, "&sceiv=");
    //dtostrf(analogRead(analogPin[2]), 1, 2, val);
    //strcat(message, val);
    //strcat(message, "&sceov=");
    //dtostrf(analogRead(analogPin[3]), 1, 2, val);
    //strcat(message, val);

    strcat(message, "\0");
    uint16_t messageLength = strlen(message);
    client.print(F("Content-Length: ")); client.println(messageLength);
    client.println();                                   // empty line as end marker of HTTP-Header before the payload
    client.print(message);
#if CLIENT_DEBUG_USART
    Serial.print(F("\nD65 messageLength=")); Serial.println(messageLength);
    Serial.println(message);
#endif
  }
  else {
    Serial.print  (F("E70: client failed. ms=")); Serial.println(millis());
    returncode = 9;
  } //if client.connected

  while (client.connected() && !client.available()) delay(1); // waits for data
  while (client.connected() || client.available()) {          // connected or data available

    char c = client.read();
    strncat(receiveBuffer, &c, 1);
    if (c == '\n' && content) {
      //Serial.print (F("<D109 EOL>")); Serial.print(F("length=")); Serial.println(strlen(receiveBuffer));
      if (strlen(receiveBuffer) < 4)
      {
        //Serial.println(F("D121 to short through away "));
        memcpy(receiveBuffer, "", 32);
      }
      else
        break; // wenn während dem content ein \n kommt, dann brechen wir aus der while schleife aus. Wir haben die erste Zeile und mehr interessiert uns nicht.
    }
    if (c == '\n' && !content)
    {
      //Serial.print(F("<EOL> length=")); Serial.println (strlen(receiveBuffer));
      if (strlen(receiveBuffer) == 2)           // bevor der Content beginnt, kommt eine Leerzeile. Eine Leerzeile hat zwei Zeichen ... wahrscheinlich \n\n
      {
        //Serial.print(F("<D123 EOL> as start marker for content"));
        content = true;                         // ab jetzt kommt dann content
      }
      receiveBuffer[0] = '\0';
    }
#if CLIENT_DEBUG_USART
    Serial.print(c);
#endif
  }
#if CLIENT_DEBUG_USART
  Serial.println();
#endif

  Serial.print(F("I: receiveBuffer=")); Serial.println(receiveBuffer);
#if CLIENT_DEBUG_USART
  for (size_t i = 0; i < strlen(receiveBuffer); i++)
  {
    Serial.print(receiveBuffer[i]);
  }
  Serial.println();
#endif
  //Serial.print(F("I: client disconnect. ms=")); Serial.println(millis());
  client.stop();

  return returncode;
}
*/
